/*
 * Title: main_hw4_3.cpp
 * Abstract: sorting using Kahn's algo.
 * Name: Keldin Maldonado
 * Date: 10/03/2023
 * Disclaimer: Most based on the provided example by GeeksForGeeks and then edited
 * for this particular class.
 */

#include <vector>
#include <list>
#include <iostream>
#include <queue>

using namespace std;
 
class Graph {
  int V;
  list<int>* adj;
 
  public:
    Graph(int V);
    void addEdge(int u, int v);
    void topologicalSort();
};
 
Graph::Graph(int V) {
  this->V = V;
  adj = new list<int>[V];
}
 
void Graph::addEdge(int u, int v) {
  adj[u].push_back(v);
}
 
void Graph::topologicalSort() {
  vector<int> in_degree(V, 0);
 
  for (int u = 0; u < V; u++) {
    for (auto it = adj[u].begin(); it != adj[u].end(); it++) {
      in_degree[*it]++;
    }
  }

  for (int i = 0; i < in_degree.size(); i++) {
    cout << "In-degree[" << i << "]:" << in_degree[i] << endl;
  }
 
  queue<int> q;
  for (int i = 0; i < V; i++) {
    if (in_degree[i] == 0) {
      q.push(i);
    }
  }
 
  int cnt = 0;

  vector<int> top_order;

  while (!q.empty()) {
    int u = q.front();
    q.pop();
    top_order.push_back(u);

    for (auto it = adj[u].begin(); it != adj[u].end(); it++) {
      if (--in_degree[*it] == 0) {
        q.push(*it);
      }
    }

    cnt++;
  }

  if (cnt != V) {
    cout << "No Order:" << endl;
    return;
  }

  cout << "Order:";

  for (int i = 0; i < top_order.size() - 1; i++) {
    cout << top_order[i] << "->";
  }

  cout << top_order[top_order.size() - 1] << endl;
}
 
int main() {
  int vertices = 0, edges = 0;
  cin >> vertices >> edges;

  Graph graph(vertices);

  int input1 = 0;
  int input2 = 0;
  for (int i = 0; i < edges; i++) {
    cin >> input1 >> input2;
    graph.addEdge(input1, input2);
  }

  graph.topologicalSort();

  return 0;
}